package ogloszenia.klient_niskopoziomowy;

import jakarta.xml.ws.Dispatch;
import jakarta.xml.ws.Service;
import ogloszenia.generated.OgloszeniaService;

import javax.xml.namespace.QName;
import javax.xml.transform.Source;
import javax.xml.transform.stream.StreamSource;
import java.io.StringReader;

public class Klient5_DispatcherXSLT {
        static final String trescXML = """
                <o:readOne xmlns:o="http://soap.ogloszenia/">
                    <id>1</id>
                </o:readOne>""";

    public static void main(String[] args) {
        System.out.println("Startujemy...");
        OgloszeniaService service = new OgloszeniaService();

        QName portName = OgloszeniaService.OgloszeniaPort;
        Dispatch<Source> dispatch = service.createDispatch(portName, Source.class, Service.Mode.PAYLOAD);
        System.out.println("Mam Dispatchera " + dispatch);

        Source src = new StreamSource(new StringReader(trescXML));
        System.out.println("Wysyłam zapytanie");
        Source result = dispatch.invoke(src);
        System.out.println("Mam wynik: " + result);
        Utils utils = new Utils();
        utils.xslt(result, "arkusz.xsl", "wynik.html");
        System.out.println("Gotowe");
    }
}
