package alx.przyklady;

import org.oorsprong.websamples.TCountryInfo;
import org.oorsprong.websamples.TLanguage;
import org.oorsprong.websamples_countryinfo.CountryInfoService;
import org.oorsprong.websamples_countryinfo.CountryInfoServiceSoapType;

import javax.swing.*;

public class PytanieOJedenKraj {
    public static void main(String[] args) {
        System.out.println("Startujemy");
        CountryInfoService service = new CountryInfoService();
        CountryInfoServiceSoapType proxy = service.getCountryInfoServiceSoap();
        System.out.println("Mam obiekt proxy: " + proxy);

        String kodKraju = JOptionPane.showInputDialog("Podaj kod kraju");
        System.out.println("Wysyłam zapytanie");
        TCountryInfo countryInfo = proxy.fullCountryInfo(kodKraju);
        System.out.println("Mam odpowiedź: " + countryInfo);

        System.out.println(countryInfo.getSISOCode() + " " + countryInfo.getSName());
        System.out.println("Stolica: " + countryInfo.getSCapitalCity());
        System.out.println("Waluta: " + countryInfo.getSCurrencyISOCode());
        System.out.println("Prefix tel: " + countryInfo.getSPhoneCode());
        System.out.println("Języki:");
        for(TLanguage lang : countryInfo.getLanguages().getTLanguage()) {
            System.out.println(" * " + lang.getSISOCode() + " " + lang.getSName());
        }
    }
}
