# Java SOAP
Repozytorium na projekty ze szkolenia "Java SOAP", ALX dla Samsung, 1.08.2023

## Oprogramowanie
Zalecam instalację następującego oprogramowania

- [Java 17](https://adoptium.net/)
  
- [IntelliJ IDEA](https://www.jetbrains.com/idea/)

- alternatywnie można też [Eclipse](https://www.eclipse.org/downloads) for Enterprise Java and Web Developers z doinstalowaną wtyczką JBoss Tools (tylko komponent "JBoss WildFly, EAP Server Tools")

- jakieś narzędzie do Gita

- [https://www.soapui.org/downloads/soapui/](SoapUI) wersja open source

- podstawowe narzędzia: przeglądarka internetowa, prosty edytor (Notepad++ lub podobny)

- sieciowy dostęp do repozytorium Mavena, do naszego gitlab.alx.pl, a w przypadku wybory edytora Eclipse do Eclipse Marketplace


## Notatki

Sposoby implementacji:
- SAAJ - SOAPMessage, za pomocą DOM + XPath operowanie na wiadomościach
- JAX-WS
    - wysoki poziom abstrakcji:
        - `@WebService` po stronie serwera
        - Obiekty proxy po stronie klienta
    - niski poziom abstrakcji, dostęp do komunikatów XML
        - `Provider` po stronie serwera
        - `Dispatcher` po stronie klienta
    - handlery - dodatkowy dostęp do komunikacji "w locie" po obu stronach (przypomina rozwiązania takie jak filter / interceptor znane znane z innych technologii)





